#include "menu.h"


#define VERSION "0.9"
char about_text[]="Pdale d'effet Virtuelle. " VERSION "\n\nGhalleb KHELIDJ\nMaitrise MIME\n2000";


GtkWidget *frame_menu;

extern GtkWidget *Fenetre_Principale;
extern GtkWidget *fenetre_fixe;


GtkWidget *menu_menubar;
GtkWidget *menu_fichier;
GtkWidget *fichier_menu;
GtkAccelGroup *fichier_menu_accels;
GtkWidget *fichier_ouvrir;
GtkWidget *fichier_enregistrer;
GtkWidget *separateur;
GtkWidget *fichier_quitter;
GtkWidget *menu_option;
GtkWidget *option_menu;
GtkAccelGroup *option_menu_accels;
GtkWidget *option_device;
GtkWidget *option_repertoire;
GtkWidget *menu_aide;
GtkWidget *aide_menu;
GtkAccelGroup *aide_menu_accels;
GtkWidget *aide_a_propros_de;

GtkWidget *quit_window=NULL;
GtkWidget *add_window=NULL;
GtkWidget *plugin_list;
GtkWidget *entry_comment;
GtkWidget *device_config_window;
GtkWidget *about_window;
  
extern int is_playing;

struct
{
  int sampling_freq;
  int buffer_size;
  char *snd_dev_name;
} temporary_config_entry;


void about_destroy(GtkWidget *w, gpointer d)
{
  if(about_window != NULL) gtk_widget_destroy(about_window);
  about_window=NULL;
}


void about(GtkWidget *w, gpointer d)
{
  GtkWidget *text, *button, *vbox;
  if(about_window) return;
  about_window=gtk_window_new(GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title(GTK_WINDOW(about_window), "About");
  gtk_container_set_border_width(GTK_CONTAINER(about_window), 5);
  gtk_signal_connect(GTK_OBJECT(about_window), "destroy", GTK_SIGNAL_FUNC(about_destroy), NULL);
  vbox=gtk_vbox_new(FALSE, 0);
  gtk_container_add(GTK_CONTAINER(about_window), vbox);
  gtk_widget_show(vbox);
  text=gtk_text_new(NULL, NULL);
  gtk_text_set_editable(GTK_TEXT(text), FALSE);
  gtk_text_insert(GTK_TEXT(text), NULL, NULL, NULL, about_text, strlen(about_text));
  gtk_box_pack_start(GTK_BOX(vbox), text, TRUE, TRUE, 0);
  gtk_widget_show(text);
  button=gtk_button_new_with_label("Ok");	
  gtk_box_pack_start(GTK_BOX(vbox), button, FALSE, FALSE, 0);
  gtk_signal_connect(GTK_OBJECT(button), "clicked", GTK_SIGNAL_FUNC(about_destroy), NULL);
  gtk_widget_show(button);
  gtk_widget_show(about_window);
}

void configure_devices_freq_11(GtkWidget *but, gpointer data)
{
  temporary_config_entry.sampling_freq=11025;
}

void configure_devices_freq_22(GtkWidget *but, gpointer data)
{
  temporary_config_entry.sampling_freq=22050;
}

void configure_devices_freq_44(GtkWidget *but, gpointer data)
{
  temporary_config_entry.sampling_freq=44100;
}



void configure_devices_buf_64(GtkWidget *but, gpointer data)
{
  temporary_config_entry.buffer_size=64;
}

void configure_devices_buf_128(GtkWidget *but, gpointer data)
{
  temporary_config_entry.buffer_size=128;
}


void configure_devices_buf_256(GtkWidget *but, gpointer data)
{
  temporary_config_entry.buffer_size=256;
}

void configure_devices_buf_1024(GtkWidget *but, gpointer data)
{
  temporary_config_entry.buffer_size=1024;
}

void configure_devices_buf_2048(GtkWidget *but, gpointer data)
{
  temporary_config_entry.buffer_size=2048;
}


void configure_devices_ok(GtkWidget *w, gpointer data)
{
  //	int plgnnum;

  temporary_config_entry.snd_dev_name=gtk_entry_get_text(GTK_ENTRY(data));
  if(is_playing) sound_stop_playing();

  strcpy(sound_device_name, temporary_config_entry.snd_dev_name);
  sampling_frequency=temporary_config_entry.sampling_freq;
  blocksize=temporary_config_entry.buffer_size;

  if(is_playing) sound_start_playing();
}


void configure_devices_cancel(GtkWidget *w, gpointer data)
{
  gtk_widget_destroy((GtkWidget *)data);
  device_config_window=NULL;
}


void configure_devices(GtkWidget *w, gpointer d)
{
  GtkWidget *vbox;
  GtkWidget *device_name_entry;
  GtkWidget *device_name_frame;
  GtkWidget *button_box;
  GtkWidget *sampling_freq_frame;
  GtkWidget *sampling_freq_button;
  GSList    *sampling_freq_button_group;
  GtkWidget *buffer_size_frame;
  GtkWidget *buffer_size_button;
  GSList    *buffer_size_button_group;
  GtkWidget *button_ok;
  GtkWidget *button_cancel;
  GtkWidget *button_box2;


  if(device_config_window != NULL) return;
	
  device_config_window=gtk_window_new(GTK_WINDOW_DIALOG);
  gtk_container_set_border_width(GTK_CONTAINER(device_config_window), 10);
  vbox=gtk_vbox_new(FALSE, 0);	
  gtk_container_add(GTK_CONTAINER(device_config_window), vbox);
	
  device_name_frame=gtk_frame_new("Input/Output device");
  /*	gtk_frame_set_shadow_type(GTK_FRAME(device_name_frame), GTK_SHADOW_OUT);*/
  gtk_widget_show(device_name_frame);

  device_name_entry=gtk_entry_new_with_max_length(30);
  gtk_entry_set_text(GTK_ENTRY(device_name_entry), sound_device_name);
  gtk_container_add(GTK_CONTAINER(device_name_frame), device_name_entry);	
  gtk_widget_show(device_name_entry);

  sampling_freq_frame=gtk_frame_new("Sampling frequency");
  /*	gtk_frame_set_shadow_type(GTK_FRAME(sampling_freq_frame), GTK_SHADOW_OUT);*/
  gtk_widget_show(sampling_freq_frame);
  buffer_size_frame=gtk_frame_new("Buffer size");
  /*	gtk_frame_set_shadow_type(GTK_FRAME(buffer_size_frame), GTK_SHADOW_OUT);*/
  gtk_widget_show(buffer_size_frame);

  button_box=gtk_vbox_new(FALSE, 0);
  gtk_container_add(GTK_CONTAINER(sampling_freq_frame), button_box);
  gtk_widget_show(button_box);

  sampling_freq_button=gtk_radio_button_new_with_label(NULL, "11 kHz");
  gtk_box_pack_start(GTK_BOX(button_box), sampling_freq_button, FALSE, FALSE, 0);
  gtk_widget_show(sampling_freq_button);
  gtk_signal_connect(GTK_OBJECT(sampling_freq_button), "clicked", GTK_SIGNAL_FUNC(configure_devices_freq_11), NULL);
  if(sampling_frequency == 11025)
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (sampling_freq_button), TRUE);

  sampling_freq_button_group=gtk_radio_button_group(GTK_RADIO_BUTTON(sampling_freq_button));
  sampling_freq_button=gtk_radio_button_new_with_label(sampling_freq_button_group, "22 kHz");
  gtk_signal_connect(GTK_OBJECT(sampling_freq_button), "clicked", GTK_SIGNAL_FUNC(configure_devices_freq_22), NULL);
  gtk_box_pack_start(GTK_BOX(button_box), sampling_freq_button, FALSE, FALSE, 0);
  gtk_widget_show(sampling_freq_button);
  if(sampling_frequency == 22050)
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (sampling_freq_button), TRUE);

  sampling_freq_button_group=gtk_radio_button_group(GTK_RADIO_BUTTON(sampling_freq_button));
  sampling_freq_button=gtk_radio_button_new_with_label(sampling_freq_button_group, "44 kHz");
  gtk_signal_connect(GTK_OBJECT(sampling_freq_button), "clicked", GTK_SIGNAL_FUNC(configure_devices_freq_44), NULL);
  gtk_box_pack_start(GTK_BOX(button_box), sampling_freq_button, FALSE, FALSE, 0);
  gtk_widget_show(sampling_freq_button);
  if(sampling_frequency == 44100)
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (sampling_freq_button), TRUE);



  button_box=gtk_vbox_new(FALSE, 0);
  gtk_container_add(GTK_CONTAINER(buffer_size_frame), button_box);
  gtk_widget_show(button_box);



  buffer_size_button=gtk_radio_button_new_with_label(NULL, "64 bytes");
  gtk_signal_connect(GTK_OBJECT(buffer_size_button), "clicked", GTK_SIGNAL_FUNC(configure_devices_buf_64), NULL);
  gtk_box_pack_start(GTK_BOX(button_box), buffer_size_button, FALSE, FALSE, 0);
  gtk_widget_show(buffer_size_button);
  if(blocksize == 64)
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (buffer_size_button), TRUE);

  buffer_size_button_group=gtk_radio_button_group(GTK_RADIO_BUTTON(buffer_size_button));
  buffer_size_button=gtk_radio_button_new_with_label(buffer_size_button_group, "128 bytes");
  gtk_signal_connect(GTK_OBJECT(buffer_size_button), "clicked", GTK_SIGNAL_FUNC(configure_devices_buf_128), NULL);
  if(blocksize == 128)
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (buffer_size_button), TRUE);
  gtk_box_pack_start(GTK_BOX(button_box), buffer_size_button, FALSE, FALSE, 0);
  gtk_widget_show(buffer_size_button);

  buffer_size_button_group=gtk_radio_button_group(GTK_RADIO_BUTTON(buffer_size_button));
  buffer_size_button=gtk_radio_button_new_with_label(buffer_size_button_group, "256 bytes");
  gtk_signal_connect(GTK_OBJECT(buffer_size_button), "clicked", GTK_SIGNAL_FUNC(configure_devices_buf_256), NULL);
  if(blocksize == 256)
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (buffer_size_button), TRUE);
  gtk_box_pack_start(GTK_BOX(button_box), buffer_size_button, FALSE, FALSE, 0);
  gtk_widget_show(buffer_size_button);

  buffer_size_button_group=gtk_radio_button_group(GTK_RADIO_BUTTON(buffer_size_button));
  buffer_size_button=gtk_radio_button_new_with_label(buffer_size_button_group, "1024 bytes");
  gtk_signal_connect(GTK_OBJECT(buffer_size_button), "clicked", GTK_SIGNAL_FUNC(configure_devices_buf_1024), NULL);
  if(blocksize == 1024)
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (buffer_size_button), TRUE);
  gtk_box_pack_start(GTK_BOX(button_box), buffer_size_button, FALSE, FALSE, 0);
  gtk_widget_show(buffer_size_button);

  buffer_size_button_group=gtk_radio_button_group(GTK_RADIO_BUTTON(buffer_size_button));
  buffer_size_button=gtk_radio_button_new_with_label(buffer_size_button_group, "2048 bytes");
  gtk_signal_connect(GTK_OBJECT(buffer_size_button), "clicked", GTK_SIGNAL_FUNC(configure_devices_buf_2048), NULL);
  gtk_box_pack_start(GTK_BOX(button_box), buffer_size_button, FALSE, FALSE, 0);
  gtk_widget_show(buffer_size_button);
  if(blocksize == 2048)
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (buffer_size_button), TRUE);

  button_box2=gtk_hbox_new(TRUE, 0);
  button_ok=gtk_button_new_with_label("Ok");
  gtk_signal_connect(GTK_OBJECT(button_ok), "clicked", GTK_SIGNAL_FUNC(configure_devices_ok), device_name_entry);
  gtk_signal_connect(GTK_OBJECT(button_ok), "clicked", GTK_SIGNAL_FUNC(configure_devices_cancel), device_config_window);
  button_cancel=gtk_button_new_with_label("Cancel");
  gtk_signal_connect(GTK_OBJECT(button_cancel), "clicked", GTK_SIGNAL_FUNC(configure_devices_cancel), device_config_window);
  gtk_widget_show(button_ok);
  gtk_widget_show(button_cancel);
  gtk_box_pack_start(GTK_BOX(button_box2), button_ok, FALSE, TRUE, 10);
  gtk_box_pack_start(GTK_BOX(button_box2), button_cancel, FALSE, TRUE, 10);
  gtk_widget_show(button_box2);

  gtk_box_pack_start(GTK_BOX(vbox), device_name_frame, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(vbox), sampling_freq_frame, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(vbox), buffer_size_frame, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(vbox), button_box2, FALSE, FALSE, 10);	
  gtk_widget_show(vbox);
  gtk_widget_show(device_config_window);
}


gint quit_rtdsp(GtkWidget *window, GdkEvent *event, gpointer data)
{
  GtkWidget *button_ok;
  GtkWidget *button_cancel;
  GtkWidget *button_box;
  GtkWidget *vbox;
  GtkWidget *question;
	
  if(quit_window!=NULL) return(TRUE);
  quit_window=gtk_window_new(GTK_WINDOW_DIALOG);
  gtk_window_set_title(GTK_WINDOW(quit_window), "Quit?");
  gtk_container_set_border_width(GTK_CONTAINER(quit_window), 20);
  button_ok=gtk_button_new_with_label("Ok");
  button_cancel=gtk_button_new_with_label("Cancel");
  button_box=gtk_hbox_new(TRUE, 10);
  vbox=gtk_vbox_new(TRUE, 10);
  question=gtk_label_new("ARE YOU SURE YOU WANT TO QUIT?");
  gtk_box_pack_start(GTK_BOX(vbox), question, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(vbox), button_box, FALSE, FALSE, 0);
  gtk_widget_show(vbox);
  gtk_widget_show(question);

  gtk_signal_connect(GTK_OBJECT(button_ok), "clicked", GTK_SIGNAL_FUNC(quit_rtdsp_ok), NULL);
  gtk_signal_connect(GTK_OBJECT(button_cancel), "clicked", GTK_SIGNAL_FUNC(quit_rtdsp_cancel), NULL);
  gtk_signal_connect(GTK_OBJECT(quit_window), "destroy", GTK_SIGNAL_FUNC(quit_rtdsp_cancel), NULL);

  gtk_box_pack_start(GTK_BOX(button_box), button_ok, TRUE, TRUE, 0);
  gtk_box_pack_start(GTK_BOX(button_box), button_cancel, TRUE, TRUE, 0);
  gtk_container_add(GTK_CONTAINER(quit_window), vbox);

  gtk_widget_show(button_ok);
  gtk_widget_show(button_cancel);
  gtk_widget_show(button_box);
  gtk_widget_show(quit_window);

  return(TRUE);
}






void quit_rtdsp_menu(GtkWidget *window, gpointer data)
{
  quit_rtdsp(NULL, NULL, NULL);
}


void quit_rtdsp_ok(GtkWidget *window, gpointer data)
{
  if(is_playing)
    {
      is_playing=0;
      sound_stop_playing();
    }
  gtk_main_quit();
}


void quit_rtdsp_cancel(GtkWidget *window, gpointer data)
{
  gtk_widget_destroy(quit_window);
  quit_window=NULL;
}





void menu_frame(void)
{
  
  frame_menu = gtk_frame_new (NULL);
  gtk_widget_ref (frame_menu);
  gtk_object_set_data_full (GTK_OBJECT (Fenetre_Principale), "frame_menu", frame_menu,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (frame_menu);
  gtk_fixed_put (GTK_FIXED (fenetre_fixe), frame_menu, 550, 0);
  gtk_widget_set_uposition (frame_menu, 550, 0);
  gtk_widget_set_usize (frame_menu, 250, 30);

  

}

void menu_main(void)
{
  menu_frame();
  menu_inter();
}

void menu_inter(void)
{

  menu_menubar = gtk_menu_bar_new ();
  gtk_widget_show (menu_menubar);
  gtk_container_add (GTK_CONTAINER (frame_menu), menu_menubar);

  menu_fichier = gtk_menu_item_new_with_label ("Fichier");
  gtk_widget_show (menu_fichier);
  gtk_container_add (GTK_CONTAINER (menu_menubar), menu_fichier);

  fichier_menu = gtk_menu_new ();
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (menu_fichier), fichier_menu);
  fichier_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (fichier_menu));

  fichier_ouvrir = gtk_menu_item_new_with_label ("Ouvrir...");
  gtk_widget_show (fichier_ouvrir);
  gtk_container_add (GTK_CONTAINER (fichier_menu), fichier_ouvrir);
  gtk_signal_connect(GTK_OBJECT(fichier_ouvrir), "activate",
		     (GtkSignalFunc)ouvrir_callback,
		     NULL);

  fichier_enregistrer = gtk_menu_item_new_with_label ("Enregistrer...");
  gtk_widget_show (fichier_enregistrer);
  gtk_container_add (GTK_CONTAINER (fichier_menu), fichier_enregistrer);
  gtk_signal_connect(GTK_OBJECT(fichier_enregistrer), "activate",
		     (GtkSignalFunc)enregistrer_callback,
		     NULL);

  separateur = gtk_menu_item_new ();
  gtk_widget_show (separateur);
  gtk_container_add (GTK_CONTAINER (fichier_menu), separateur);
  gtk_widget_set_sensitive (separateur, FALSE);

  fichier_quitter = gtk_menu_item_new_with_label ("Quitter");
  gtk_widget_show (fichier_quitter);
  gtk_container_add (GTK_CONTAINER (fichier_menu), fichier_quitter);
  gtk_signal_connect(GTK_OBJECT(fichier_quitter), "activate",
		     (GtkSignalFunc)gtk_exit,
		     NULL);

  menu_option = gtk_menu_item_new_with_label ("Options");
  gtk_widget_show (menu_option);
  gtk_container_add (GTK_CONTAINER (menu_menubar), menu_option);

  option_menu = gtk_menu_new ();
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (menu_option), option_menu);
  option_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (option_menu));

  option_device = gtk_menu_item_new_with_label ("Device");
  gtk_widget_show (option_device);
  gtk_container_add (GTK_CONTAINER (option_menu), option_device);
  gtk_signal_connect(GTK_OBJECT(option_device), "activate",
		     (GtkSignalFunc)configure_devices,
		     NULL);

  option_repertoire = gtk_menu_item_new_with_label ("Rpertoire");
  gtk_widget_show (option_repertoire);
  gtk_container_add (GTK_CONTAINER (option_menu), option_repertoire);
  gtk_signal_connect(GTK_OBJECT(option_repertoire), "activate",
		     (GtkSignalFunc)repertoire_callback,
		     NULL);

  menu_aide = gtk_menu_item_new_with_label ("Aide");
  gtk_widget_show (menu_aide);
  gtk_container_add (GTK_CONTAINER (menu_menubar), menu_aide);
  gtk_menu_item_right_justify (GTK_MENU_ITEM (menu_aide));

  aide_menu = gtk_menu_new ();
  gtk_menu_item_set_submenu (GTK_MENU_ITEM (menu_aide), aide_menu);
  aide_menu_accels = gtk_menu_ensure_uline_accel_group (GTK_MENU (aide_menu));

  aide_a_propros_de = gtk_menu_item_new_with_label ("A propros de");
  gtk_widget_show (aide_a_propros_de);
  gtk_container_add (GTK_CONTAINER (aide_menu), aide_a_propros_de);
  gtk_signal_connect(GTK_OBJECT(aide_a_propros_de), "activate",
		     (GtkSignalFunc)about,
		     NULL);

}


gboolean AfficheFichier(GtkFileSelection *Sel)
{
  gchar *NomFichier;

  NomFichier = gtk_file_selection_get_filename(Sel);
  printf("Fichier slectionn : %s\n", NomFichier);
  return TRUE;
}


void ouvrir_callback(GtkWidget *window, gpointer data)
{
  GtkFileSelection *FichierDlg;
  

  /* Cration du dialogue de slection de fichiers */
  FichierDlg = (GtkFileSelection *)
    gtk_file_selection_new("Ouvrir ...");
  /* Connexion des signaux "delete" et "destroy" */
  gtk_signal_connect(GTK_OBJECT(FichierDlg), "delete_event",
                     (GtkSignalFunc)gtk_exit, NULL);
  gtk_signal_connect(GTK_OBJECT(FichierDlg), "destroy",
                     (GtkSignalFunc)gtk_exit, NULL);

  /* On slectionne un fichier par dfaut */
  gtk_file_selection_set_filename(FichierDlg,
				  "/home/ghalleb/");
  /* Gestion des signaux du bouton 'OK' */
  gtk_signal_connect_object(
			    GTK_OBJECT(FichierDlg->ok_button),
			    "clicked",
			    (GtkSignalFunc)AfficheFichier,
			    GTK_OBJECT(FichierDlg));
  gtk_signal_connect_object(
			    GTK_OBJECT(FichierDlg->ok_button),
			    "clicked",
			    (GtkSignalFunc)gtk_widget_hide,
			    GTK_OBJECT(FichierDlg));
  /* Gestion des signaux du bouton 'Cancel' */
  gtk_signal_connect_object(
			    GTK_OBJECT(FichierDlg->cancel_button),
			    "clicked",
			    (GtkSignalFunc)gtk_widget_hide,
			    GTK_OBJECT(FichierDlg));

  /* On affiche le dialogue */
  gtk_widget_show(GTK_WIDGET(FichierDlg));


}

void enregistrer_callback(GtkWidget *window, gpointer data)
{ 
  GtkFileSelection *FichierDlg;
  

  /* Cration du dialogue de slection de fichiers */
  FichierDlg = (GtkFileSelection *)
    gtk_file_selection_new("Enregistrer ...");
  /* Connexion des signaux "delete" et "destroy" */
  gtk_signal_connect(GTK_OBJECT(FichierDlg), "delete_event",
                     (GtkSignalFunc)gtk_exit, NULL);
  gtk_signal_connect(GTK_OBJECT(FichierDlg), "destroy",
                     (GtkSignalFunc)gtk_exit, NULL);

  /* On slectionne un fichier par dfaut */
  gtk_file_selection_set_filename(FichierDlg,
				  "/home/ghalleb/");
  /* Gestion des signaux du bouton 'OK' */
  gtk_signal_connect_object(
			    GTK_OBJECT(FichierDlg->ok_button),
			    "clicked",
			    (GtkSignalFunc)AfficheFichier,
			    GTK_OBJECT(FichierDlg));
  gtk_signal_connect_object(
			    GTK_OBJECT(FichierDlg->ok_button),
			    "clicked",
			    (GtkSignalFunc)gtk_widget_hide,
			    GTK_OBJECT(FichierDlg));
  /* Gestion des signaux du bouton 'Cancel' */
  gtk_signal_connect_object(
			    GTK_OBJECT(FichierDlg->cancel_button),
			    "clicked",
			    (GtkSignalFunc)gtk_widget_hide,
			    GTK_OBJECT(FichierDlg));

  /* On affiche le dialogue */
  gtk_widget_show(GTK_WIDGET(FichierDlg));


}

void repertoire_callback(GtkWidget *window, gpointer data)
{
}


