#include "moteur.h"


InternalPlugin loaded_plugins_data[MAX_NUMBER_OF_PLUGINS];

GtkWidget *entry_comment;
GtkWidget *plugin_list;


int loaded_plugins_num=0;
int is_playing=0;
int list_playing=0;

extern int number_of_founded_plugins;
extern int selected_plugin_add_num;
extern int sampling_frequency;
extern int blocksize;
extern short int *process_buffer;
extern int selected_plugin_num;
extern GtkWidget *entry1;


void moteur(void)
{

}


void add_window_append(GtkWidget *button, gpointer data)
{
  gchar *rownames[2];
  int new_plugin_list_row;
  int rownum;
  InternalPlugin temp_plugin;
  
  if(loaded_plugins_num >= MAX_NUMBER_OF_PLUGINS) return;
  if(number_of_founded_plugins == 0) return;
  
  gtk_clist_get_text((GtkCList *)data, selected_plugin_add_num, 0, &rownames[0]);
  if(load_plugin_from_disk(rownames[0], &temp_plugin))	
    {
      return;
    }
  
  if(loaded_plugins_num > 0)
    {
      new_plugin_list_row=selected_plugin_num + 1;
      if(selected_plugin_num < (loaded_plugins_num - 1))
	{
	  for(rownum=(loaded_plugins_num - 1); rownum > selected_plugin_num; rownum--)
	    {
	      memcpy(&loaded_plugins_data[rownum + 1],&loaded_plugins_data[rownum], sizeof(InternalPlugin));
	    }
	}
    }
  else
    {
      new_plugin_list_row=0;
    }
  
  memcpy(&loaded_plugins_data[new_plugin_list_row], &temp_plugin, sizeof(InternalPlugin));
  gtk_clist_get_text((GtkCList *)data, selected_plugin_add_num, 0, &rownames[1]);
  gtk_clist_get_text((GtkCList *)data, selected_plugin_add_num, 1, &rownames[0]);
  
  //	rownames[1]=gtk_entry_get_text(GTK_ENTRY(entry_comment));
  gtk_clist_insert(GTK_CLIST(plugin_list), new_plugin_list_row, rownames);
  if(loaded_plugins_num == 0) gtk_clist_select_row(GTK_CLIST(plugin_list), 0, 0);
  else
    {
      selected_plugin_num++;
      gtk_clist_select_row(GTK_CLIST(plugin_list), selected_plugin_num, 0);
    }
  
  if(loaded_plugins_data[new_plugin_list_row].init != NULL)
    {
      loaded_plugins_data[new_plugin_list_row].data=loaded_plugins_data[new_plugin_list_row].init();
    }
  
  loaded_plugins_num++;
}

void remove_plugin_from_list(GtkWidget *button, gpointer data)
{
  //	gchar *rownames[2];
  int rownum;

  if(loaded_plugins_num == 0) return;
  if(loaded_plugins_data[selected_plugin_num].cleanup != NULL)
    {
      loaded_plugins_data[selected_plugin_num].cleanup(loaded_plugins_data[selected_plugin_num].data);
    }
  dlclose(loaded_plugins_data[selected_plugin_num].handle);
  if(selected_plugin_num < (loaded_plugins_num - 1))
    {
      for(rownum=selected_plugin_num; rownum < loaded_plugins_num; rownum++)
	{
	  memcpy(&loaded_plugins_data[rownum], &loaded_plugins_data[rownum + 1], sizeof(InternalPlugin));		
	}
    }

  loaded_plugins_num--;
  memset(&loaded_plugins_data[loaded_plugins_num], 0, sizeof(InternalPlugin));
  gtk_clist_remove(GTK_CLIST(plugin_list), selected_plugin_num);
  if(selected_plugin_num == loaded_plugins_num)
    gtk_clist_select_row(GTK_CLIST(plugin_list), selected_plugin_num - 1, 0);
  else
    gtk_clist_select_row(GTK_CLIST(plugin_list), selected_plugin_num, 0);
}



void configure_plugin(GtkWidget *button, gpointer data)
{
  if(loaded_plugins_data[selected_plugin_num].configure == NULL) return;
  loaded_plugins_data[selected_plugin_num].configure(loaded_plugins_data[selected_plugin_num].data);
}


void print_error_message_destroy(GtkWidget *w, gpointer data)
{
  gtk_widget_destroy((GtkWidget *)data);
}


void print_error_message(gchar *message)
{
  GtkWidget *window;
  GtkWidget *text;
  GtkWidget *button_ok;
  GtkWidget *vbox;

  window=gtk_window_new(GTK_WINDOW_DIALOG);
  gtk_container_set_border_width(GTK_CONTAINER(window), 10);	
  gtk_window_set_title(GTK_WINDOW(window), "Error");
  gtk_widget_set_usize(window, 200, 100);
  gtk_signal_connect(GTK_OBJECT(window), "destroy", GTK_SIGNAL_FUNC(print_error_message_destroy), window);
	
  vbox=gtk_vbox_new(TRUE, 10);
  gtk_widget_show(vbox);

  button_ok=gtk_button_new_with_label("Ok");		
  gtk_widget_show(button_ok);
  gtk_signal_connect(GTK_OBJECT(button_ok), "clicked", GTK_SIGNAL_FUNC(print_error_message_destroy), window);

  text=gtk_label_new(message);
  gtk_widget_show(text);

  gtk_box_pack_start(GTK_BOX(vbox), text, FALSE, FALSE, 0);
  gtk_box_pack_start(GTK_BOX(vbox), button_ok, FALSE, FALSE, 0);

  gtk_container_add(GTK_CONTAINER(window), vbox);
  gtk_widget_show(window);
}


void process_start_stop(GtkWidget *button, gpointer data)
{
  int licznik=0;
  int licznik_max;
  int prev_smpfreq, prev_blksize;
  int plgnnum;
  int error;

  if(list_playing)
    {
      list_playing=0;
      //gtk_label_set((GtkLabel *)data , "ON");
      sound_stop_playing();
    }
 
  if(is_playing)
    {
      is_playing=0;
      gtk_label_set((GtkLabel *)data , "ON");
      sound_stop_playing();
    }
  else
    {
      if((error=sound_start_playing()) != 0)
	{
	  switch(error)
	    {
	    case 1:       /* Device not available or busy */
	      print_error_message("Device is not available or busy");
	      break;
	    case 2:       /* Device doesn't support full duplex */
	      print_error_message("Device doesn't support full-duplex mode");
	      break;
	    case 3:       /* Device doesn't support such sampling frequency */
	      print_error_message("Device doesn't support such sampling frequency");
	      break;
	    }

	  return;
	}

      is_playing=1;
      gtk_label_set((GtkLabel *)data, "OFF");
      licznik_max=sampling_frequency * 2 / blocksize / 10;
      licznik=0;
      prev_smpfreq=sampling_frequency;
      prev_blksize=blocksize;

      while(is_playing)
	{
	  sound_read();
	  if(loaded_plugins_num > 0)
	    for(plgnnum=0; plgnnum < loaded_plugins_num; plgnnum++)
	      {
		if(loaded_plugins_data[plgnnum].process != NULL)
		  {
		    loaded_plugins_data[plgnnum].process(loaded_plugins_data[plgnnum].data,
							 process_buffer, blocksize, sampling_frequency);
		  }
	      }
	  sound_write();
			
	  licznik++;
	  if(licznik >= licznik_max)
	    {
	      while (gtk_events_pending())
		gtk_main_iteration();
	      licznik=0;
	      if((prev_smpfreq != sampling_frequency) || (prev_blksize != blocksize))
		{
		  licznik_max=sampling_frequency * 2 / blocksize / 10;
		  prev_smpfreq=sampling_frequency;
		  prev_blksize=blocksize;
		}
	    }
	}
    }
}

int load_plugin_from_disk(char *filename, InternalPlugin *where)
{
  char fullfilename[256]=PLUGINS_PATH;
  Plugin *plugininfo;
  Plugin *(*get_plugin_info)(void);
  void *handle;
	

  strcat(fullfilename, "/");
  strcat(fullfilename, filename);
  if((handle=dlopen(fullfilename, RTLD_NOW)) == NULL) return 1;
  if((get_plugin_info=dlsym(handle, "get_plugin_info")) != NULL)
    {
      where->handle=handle;
      plugininfo=get_plugin_info();
      where->name=plugininfo->name;
      where->init=plugininfo->init;
      where->cleanup=plugininfo->cleanup;
      where->process=plugininfo->process;
      where->configure=plugininfo->configure;
      where->data=NULL;
      return 0;
    }	
  else
    {
      dlclose(handle);
      return 1;
    }
}


void list_start_stop(GtkWidget *button, gpointer data)
{
  int licznik=0;
  int licznik_max;
  int prev_smpfreq, prev_blksize;
  int plgnnum;
  int error;

  if(is_playing)
    {
      is_playing=0;
      //gtk_label_set((GtkLabel *)data , "ON");
      sound_stop_playing();
    }

  if(list_playing)
    {
      list_playing=0;
      gtk_label_set((GtkLabel *)data , "ON");
      sound_stop_playing();
    }


  else
    {
      if((error=sound_start_playing()) != 0)
	{
	  switch(error)
	    {
	    case 1:       /* Device not available or busy */
	      print_error_message("Device is not available or busy");
	      break;
	    case 2:       /* Device doesn't support full duplex */
	      print_error_message("Device doesn't support full-duplex mode");
	      break;
	    case 3:       /* Device doesn't support such sampling frequency */
	      print_error_message("Device doesn't support such sampling frequency");
	      break;
	    }

	  return;
	}

      list_playing=1;
      gtk_label_set((GtkLabel *)data, "OFF");
      licznik_max=sampling_frequency * 2 / blocksize / 10;
      licznik=0;
      prev_smpfreq=sampling_frequency;
      prev_blksize=blocksize;

      while(list_playing)
	{
	  sound_read();
	  if(loaded_plugins_num > 0)
	    for(plgnnum=0; plgnnum < loaded_plugins_num; plgnnum++)
	      {
		if(loaded_plugins_data[plgnnum].process != NULL)
		  {
		    loaded_plugins_data[plgnnum].process(loaded_plugins_data[plgnnum].data,
							 process_buffer, blocksize, sampling_frequency);
		  }
	      }
	  sound_write();
			
	  licznik++;
	  if(licznik >= licznik_max)
	    {
	      while (gtk_events_pending())
		gtk_main_iteration();
	      licznik=0;
	      if((prev_smpfreq != sampling_frequency) || (prev_blksize != blocksize))
		{
		  licznik_max=sampling_frequency * 2 / blocksize / 10;
		  prev_smpfreq=sampling_frequency;
		  prev_blksize=blocksize;
		}
	    }
	}
    }
}


void add_list_append(GtkWidget *button, gpointer data)
{
  gchar *rownames[ MAX_NUMBER_OF_PLUGINS + 1];
  int new_plugin_list_row;
  int rownum;
  
  int debut_temp;  
  InternalPlugin temp_plugin;
  
  if(number_of_founded_plugins == 0) return;
  if(gtk_entry_get_text(GTK_ENTRY(entry1)) == "") return;
  

  debut_temp = atoi (gtk_entry_get_text(GTK_ENTRY(entry1)));

  printf (" entry %d\n",debut_temp);


  gtk_clist_get_text((GtkCList *)data, selected_plugin_add_num, 0, &rownames[0]);
  if(load_plugin_from_disk(rownames[0], &temp_plugin))	
    {
      return;
    }
  
  if(loaded_plugins_num > 0)
    {
      new_plugin_list_row=selected_plugin_num + 1;
      if(selected_plugin_num < (loaded_plugins_num - 1))
	{
	  for(rownum=(loaded_plugins_num - 1); rownum > selected_plugin_num; rownum--)
	    {
	      memcpy(&loaded_plugins_data[rownum + 1],&loaded_plugins_data[rownum], sizeof(InternalPlugin));
	    }
	}
    }
  else
    {
      new_plugin_list_row=0;
    }
  
  memcpy(&loaded_plugins_data[new_plugin_list_row], &temp_plugin, sizeof(InternalPlugin));
  gtk_clist_get_text((GtkCList *)data, selected_plugin_add_num, 0, &rownames[1]);
  gtk_clist_get_text((GtkCList *)data, selected_plugin_add_num, 1, &rownames[0]);
  
  //	rownames[1]=gtk_entry_get_text(GTK_ENTRY(entry_comment));
  gtk_clist_insert(GTK_CLIST(plugin_list), new_plugin_list_row, rownames);
  if(loaded_plugins_num == 0) gtk_clist_select_row(GTK_CLIST(plugin_list), 0, 0);
  else
    {
      selected_plugin_num++;
      gtk_clist_select_row(GTK_CLIST(plugin_list), selected_plugin_num, 0);
    }
  
  if(loaded_plugins_data[new_plugin_list_row].init != NULL)
    {
      loaded_plugins_data[new_plugin_list_row].data=loaded_plugins_data[new_plugin_list_row].init();
    }
  
  loaded_plugins_num++;
}


