#ifndef __MOTEUR_H_
#define __MOTEUR_H_

#define MAX_NUMBER_OF_PLUGINS 32

#define PLUGINS_PATH "/home/ghalleb/Maitrise/plugins"

#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>
#include <dlfcn.h>
#include <stdio.h>

#include "plugin.h"

typedef struct
{
	char *name;
	char comment[80];
	void *handle;
	void *data;
	void (*cleanup)(void *data);
	void *(*init)(void);
	void (*configure)(void *data);
 	int (*process)(void *data, short int *smpdata, int size, int sampling_frequency);
} InternalPlugin;



void moteur(void);
void add_window_append(GtkWidget *button, gpointer data);
void add_list_append(GtkWidget *button, gpointer data);
void remove_plugin_from_list(GtkWidget *button, gpointer data);
void configure_plugin(GtkWidget *button, gpointer data);
void print_error_message_destroy(GtkWidget *w, gpointer data);
void print_error_message(gchar *message);
void process_start_stop(GtkWidget *button, gpointer data);
void list_start_stop(GtkWidget *button, gpointer data);
int load_plugin_from_disk(char *filename, InternalPlugin *where);

extern int sound_start_playing(void);
extern void sound_stop_playing(void);
extern int sound_write(void);
extern int sound_read(void);

#endif
