#include "panneau.h"

#ifndef PLUGINS_PATH
//#define PLUGINS_PATH "/home/ghalleb/Maitrise/plugins"
#define PLUGINS_PATH "./plugins"
#endif



GtkWidget *frame_panneau;
GtkWidget *panneau_notebook;
GtkWidget *empty_notebook_page;
GtkWidget *page1;
GtkWidget *page2;
GtkWidget *page3;

GtkWidget *drawzone;

GdkPixmap *pixmap = NULL;
GtkWidget *drawing_area;
GtkWidget *vbox;
GtkWidget *button;

GtkWidget *vbox7;
GtkWidget *scrolledwindow1;
GtkWidget *clist_list;
GtkWidget *label33;


GtkWidget *label_list[MAX_NUMBER_OF_PLUGINS];

GtkWidget *hbox12;
GtkWidget *label24;
GtkWidget *entry1;


extern GtkWidget *Fenetre_Principale;
extern GtkWidget *fenetre_fixe;

extern int mode;

GtkWidget *list;

int number_of_founded_plugins=0;
int selected_plugin_add_num=0;


static gint configure_event( GtkWidget         *widget,
			     GdkEventConfigure *event )
{
  if (pixmap)
    gdk_pixmap_unref(pixmap);
  
  pixmap = gdk_pixmap_new(widget->window,
			  widget->allocation.width,
			  widget->allocation.height,
			  -1);
  gdk_draw_rectangle (pixmap,
		      widget->style->white_gc,
		      TRUE,
		      0, 0,
		      widget->allocation.width,
		      widget->allocation.height);
  
  return TRUE;
}


static gint expose_event( GtkWidget      *widget,
			  GdkEventExpose *event )
{
  gdk_draw_pixmap(widget->window,
		  widget->style->fg_gc[GTK_WIDGET_STATE (widget)],
		  pixmap,
		  event->area.x, event->area.y,
		  event->area.x, event->area.y,
		  event->area.width, event->area.height);

  gdk_draw_line(pixmap, drawing_area->style->black_gc, 0, widget->allocation.height / 4, widget->allocation.width, widget->allocation.height  / 4); 
  gdk_draw_line(pixmap, drawing_area->style->black_gc, 0, widget->allocation.height * 3 / 4, widget->allocation.width, widget->allocation.height * 3 / 4); 

  return FALSE;
}



void panneau_frame(void)
{
  // La Frame Panneau

  frame_panneau = gtk_frame_new ("Rack");
  gtk_widget_show (frame_panneau);
  gtk_fixed_put (GTK_FIXED (fenetre_fixe), frame_panneau, 0, 64);
  gtk_widget_set_uposition (frame_panneau, 0, 64);
  gtk_widget_set_usize (frame_panneau, 550, 400);


  panneau_notebook = gtk_notebook_new ();
  gtk_widget_show (panneau_notebook);
  gtk_container_add (GTK_CONTAINER (frame_panneau), panneau_notebook);
  GTK_WIDGET_UNSET_FLAGS (panneau_notebook, GTK_CAN_FOCUS);
  gtk_notebook_set_show_tabs (GTK_NOTEBOOK (panneau_notebook), FALSE);



}

void panneau_main(void)
{
  panneau_frame();
  panneau_oscilloscope();
  panneau_rack();
  panneau_liste();
  panneau_inter(2);
}

void panneau_inter(int valeur)
{
  gtk_notebook_set_page( GTK_NOTEBOOK(panneau_notebook), (gint) (valeur - 1));

  mode = valeur;
  label();
}

void panneau_oscilloscope(void)
{


  drawing_area = gtk_drawing_area_new ();
  gtk_drawing_area_size (GTK_DRAWING_AREA (drawing_area), 500, 500);
	
  gtk_container_add (GTK_CONTAINER (panneau_notebook), drawing_area);

  gtk_widget_show (drawing_area);

  gtk_signal_connect (GTK_OBJECT (drawing_area), "expose_event",
		      (GtkSignalFunc) expose_event, NULL);
  gtk_signal_connect (GTK_OBJECT(drawing_area),"configure_event",
		      (GtkSignalFunc) configure_event, NULL);


  page1 = gtk_label_new ("Oscilloscope");
  gtk_widget_show (page1);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (panneau_notebook), gtk_notebook_get_nth_page (GTK_NOTEBOOK (panneau_notebook), 0), page1);


}

void panneau_liste(void)
{  
  int incre;

  vbox7 = gtk_vbox_new (FALSE, 0);
  gtk_widget_show (vbox7);
  gtk_container_add (GTK_CONTAINER (panneau_notebook), vbox7);

  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow1);
  gtk_box_pack_start (GTK_BOX (vbox7), scrolledwindow1, TRUE, TRUE, 0);
  gtk_widget_set_usize (scrolledwindow1, -2, 340);
  gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolledwindow1), GTK_POLICY_ALWAYS, GTK_POLICY_AUTOMATIC);

  clist_list = gtk_clist_new (MAX_NUMBER_OF_PLUGINS + 1);
  gtk_widget_show (clist_list);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), clist_list);

  
  gtk_clist_set_column_width (GTK_CLIST (clist_list), 0, 46);


  for (incre=1; incre <= MAX_NUMBER_OF_PLUGINS; incre++)
    {
      gtk_clist_set_column_width (GTK_CLIST (clist_list), incre, 70);
    }


  gtk_clist_column_titles_show (GTK_CLIST (clist_list));

 
  
  label33 = gtk_label_new ("Temps");
  gtk_widget_show (label33);
  gtk_clist_set_column_widget (GTK_CLIST (clist_list), 0, label33);
  gtk_widget_set_usize (label33, 16, -2);
 

  
  for (incre=1; incre <= MAX_NUMBER_OF_PLUGINS; incre++)
    {
      
      label_list[incre] = gtk_label_new (g_strdup_printf("effet %d", incre));
      gtk_widget_show (label_list[incre]);
      gtk_clist_set_column_widget (GTK_CLIST (clist_list), incre, label_list[incre]);
      
    }


  hbox12 = gtk_hbox_new (FALSE, 0);
  gtk_widget_show (hbox12);
  gtk_box_pack_start (GTK_BOX (vbox7), hbox12, TRUE, TRUE, 0);

  label24 = gtk_label_new ("Temps du Debut du lancement de l'effet:  ");
  gtk_widget_show (label24);
  gtk_box_pack_start (GTK_BOX (hbox12), label24, FALSE, FALSE, 0);
  gtk_widget_set_usize (label24, -2, 24);

  entry1 = gtk_entry_new ();
  gtk_widget_show (entry1);
  gtk_box_pack_start (GTK_BOX (hbox12), entry1, TRUE, TRUE, 0);
  gtk_widget_set_usize (entry1, -2, 24);


  page3 = gtk_label_new ("Liste");
  gtk_widget_show (page3);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (panneau_notebook), gtk_notebook_get_nth_page (GTK_NOTEBOOK (panneau_notebook), 2), page3);

}

void panneau_rack(void)
{
  GtkWidget *scrolled_win;
  
  list=gtk_clist_new(2);

  gtk_clist_set_column_title(GTK_CLIST(list), 0, "Fichier");
  gtk_clist_set_column_title(GTK_CLIST(list), 1, "Nom du Plugin");
  gtk_clist_column_titles_show(GTK_CLIST(list));
  gtk_clist_column_titles_passive(GTK_CLIST(list));
  gtk_clist_set_selection_mode(GTK_CLIST(list), GTK_SELECTION_SINGLE);
  gtk_clist_set_shadow_type(GTK_CLIST(list), GTK_SHADOW_OUT);
  gtk_clist_set_column_width(GTK_CLIST(list), 0, 200);

  gtk_signal_connect(GTK_OBJECT(list), "select_row", GTK_SIGNAL_FUNC(select_row_add_list), NULL);
  
  find_all_plugins(list);
  if(number_of_founded_plugins > 0) gtk_clist_select_row(GTK_CLIST(list), 0, 0);
  
  scrolled_win=gtk_scrolled_window_new(NULL, NULL);
  gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrolled_win), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
  gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(scrolled_win), list);
  
  
  gtk_container_add(GTK_CONTAINER(panneau_notebook), scrolled_win);
  
  gtk_widget_show(list);
  gtk_widget_show(scrolled_win);

  page2 = gtk_label_new ("Rack");
  gtk_widget_show (page2);
  gtk_notebook_set_tab_label (GTK_NOTEBOOK (panneau_notebook), gtk_notebook_get_nth_page (GTK_NOTEBOOK (panneau_notebook), 1), page2);

}


void select_row_add_list(GtkWidget *list, gint row, gint column, GdkEventButton *event, gpointer data)
{
  selected_plugin_add_num=row;
}

void find_all_plugins(GtkWidget *list)
{
  DIR *dp;
  struct dirent *wpis;
  struct stat statbufor;
  gchar *list_row[2];

  number_of_founded_plugins=0;
  if((dp=opendir(PLUGINS_PATH)) == NULL) return;
  chdir(PLUGINS_PATH);

  while((wpis=readdir(dp)) != NULL)
    {
      stat(wpis->d_name, &statbufor);
      if(S_ISREG(statbufor.st_mode))
	{
	  list_row[1]=get_plugin_name(wpis->d_name);
	  if(list_row[1] != NULL)
	    {
	      list_row[0]=wpis->d_name;
	      gtk_clist_append(GTK_CLIST(list), list_row);
	      number_of_founded_plugins++;
	    }
	}
    }

  closedir(dp);
  chdir("..");
}



gchar *get_plugin_name(gchar *filename)
{
  gchar fullfilename[256]=PLUGINS_PATH;
  static gchar pname[256];
  void *handle;
  Plugin *plugininfo;
  Plugin *(*get_plugin_info)(void);

  if(strcmp(&filename[strlen(filename) - 2], "so")) return NULL;
  strcat(fullfilename, "/");
  strcat(fullfilename, filename);
  if((handle=dlopen(fullfilename, RTLD_NOW)) == NULL) return NULL;
  if((get_plugin_info=dlsym(handle, "get_plugin_info")) != NULL)
    {
      plugininfo=get_plugin_info();
      strcpy(pname, plugininfo->name);
      dlclose(handle);
      return pname;
    }
	
  dlclose(handle);
  return NULL;
}
